unit NNNodeStructure;



interface


type
    TNNNode = Class(TObject)
    private
        FData:Pointer;
        FSize:Integer;
        function GetData:Pointer;
    public
        Next:TNNNode;
        Prev:TNNNode;
        property Data:Pointer read FData;
        property Size:Integer read FSize;
        constructor Create(_data:Pointer;_size:Integer);
        //ʂ̃|C^ƂĎgꍇ́A_size0ɂ
        destructor Destroy;override;
    end;

implementation

constructor TNNNode.Create(_data:Pointer;_size:Integer);
begin
    inherited Create;
    if _size>0 then begin
        //m
        GetMem(FData,_size);
        //̂̂ɃRs[
        Move(_data^,FData^,_size);
        FSize:=_size;
    end else begin
        FData:=_data;
        FSize:=0;
    end;
end;

destructor TNNNode.Destroy;
begin
    if FSize>0 then begin
        //
        FreeMem(FData,FSize);
    end;
    inherited Destroy;
end;

function TNNNode.GetData:Pointer;
begin
    if FSize>0 then begin
        //AhXԂ
        Result:=@FData;
    end else begin
        //̂܂ܕԂ
        Result:=FData;
    end;
end;

end.
